.include "atmega48.hdr"
	

	.equ res=3
	.equ sda=4
	.equ scl=5


start:		ldi r16,$02
			out _sph,r16
			ser r16
			out _spl,r16

			ldi r16,$38
			out _ddrb,r16
			ldi r16,$07
			out _portb,r16
		
			cbi _portb,res
			rcall pause		; 
			sbi _portb,res
;		
			ldi r30,20
pss:		rcall pause
			dec r30
			brne pss
			rcall lcd_init

lcd_test:

			ldi r16,7		;   	
			rcall set_color	; 
			rcall lcd_clr
			
			clt
			clr r6
			clr r7
			ldi r30,low(monitor*2)
			ldi r31,high(monitor*2)
			rcall text
	
			set
			clr r6
			ldi r16,8
			mov r7,r16
			rcall set_xy
			ldi r30,low(privet*2)
			ldi r31,high(privet*2)
			rcall text
	
			
			clt
			ldi r25,1
			ldi r16,16
			mov r7,r16
loop:			
			
			ldi r16,8
			add r7,r16
			clr r6
			rcall set_xy
			mov r16,r25
			push r16
			rcall set_color
			ldi r30,low(lcd_t230*2)
			ldi r31,high(lcd_t230*2)
			rcall text
			pop r16
			swap r16
			rcall set_color
			ldi r30,low(lcd_t230*2)
			ldi r31,high(lcd_t230*2)
			rcall text
			inc r25
			cpi r25,8
			brcs loop
						
			rcall i2c_stop
stop:
			rjmp stop		

monitor:	.db 'M','O','N','I','T','O','R','.','N','E','T','.','R','U',0
privet:		.db 'p','r','i','w','e','t',0
lcd_t230:	.db 'L','C','D','_','T','2','3','0',0


text:		lpm r16,z+
			cpi r16,0
			breq text_ex
			push r31
			push r30
			rcall symbol
			pop r30
			pop r31
			rjmp text
text_ex:	ret

prb_17:
			ldi r23,17
p17:
			ldi r16,' '
			rcall symbol
			dec r23
			brne p17
			ret


pause:		clr r17
pz0:		rcall zad
			dec r17
			brne pz0

zad:		ldi r31,25
zad0:		dec r31
			brne zad0
			ret	
			
;
lcd_init:	ldi r19,$29			;lcd capacitance
			rcall lcd_com

			ldi r19,$ea			;v bias rate
			rcall lcd_com

			rcall i2c_start
			ldi r17,$78
			rcall i2c_out
			ldi r17,$81			;vbias pot
			rcall i2c_out
			ldi r17,$a8
			rcall i2c_out		;potentiometr
			rcall i2c_stop
			rcall pause

			ldi r19,$27			;temp comp
			rcall lcd_com

			ldi r19,$8b			;auto_increment order=1
			rcall lcd_com

			ldi r19,$af			;ldc enable
			rcall lcd_com	

			ldi r19,$d4			;256 colors
			rcall lcd_com
	
			ldi r19,$a1			;line rate
			rcall lcd_com

			rcall i2c_start
			ldi r17,$7a
			rcall i2c_out
			ret

;  
lcd_com:	;r19 
	
			rcall i2c_start
			ldi r17,$78
			rcall i2c_out
			mov r17,r19
			rcall i2c_out
			rcall i2c_stop
			rcall pause
			ret


set_xy:		;  r6 - x r7 - y
			rcall i2c_stop
			rcall i2c_start
			ldi r17,$78
			rcall i2c_out
			mov r17,r6
			andi r17,$0f
			rcall i2c_out
			rcall i2c_stop
	
			rcall i2c_start
			ldi r17,$78
			rcall i2c_out
			mov r17,r6
			swap r17
			andi r17,$07
			ori r17,$10
			rcall i2c_out
			rcall i2c_stop
	
			rcall i2c_start
			ldi r17,$78
			rcall i2c_out
			mov r17,r7
			andi r17,$0f
			ori r17,$60
			rcall i2c_out
			rcall i2c_stop
			rcall i2c_start
			ldi r17,$78
			rcall i2c_out
			mov r17,r7
			swap r17
			andi r17,$07
			ori r17,$70
			rcall i2c_out
			rcall i2c_stop
	
			rcall i2c_start
			ldi r17,$7a
			rcall i2c_out
			ret


i2c_start:
			sbi _ddrb,sda
			sbi _ddrb,scl
	
			sbi _portb,sda
			sbi _portb,scl
			nop
			nop
			cbi _portb,sda
			nop
			nop
			cbi _portb,scl
			ret

i2c_stop:
			sbi _ddrb,sda
			sbi _ddrb,scl

			cbi _portb,sda
			sbi _portb,scl
			nop
			nop
			sbi _portb,sda
			nop
			nop
			cbi _portb,scl
			ret
	

;r17 out i2c
i2c_out:
			push r17
			cbi _portb,sda
			sbi _ddrb,sda
			ldi r18,8
i2c_out1:
			sbrc r17,7
			sbi _portb,sda
			sbrs r17,7
			cbi _portb,sda
			nop
			sbi _portb,scl
			nop
			cbi _portb,scl
			lsl r17
			dec r18
			brne i2c_out1
			cbi _ddrb,sda
			sbi _portb,scl
			nop
			cbi _portb,scl
			pop r17
			ret	

;  r16   t=1 , t=0 
symbol:

			subi r16,$20
			ldi r30,low(znak*2)
			ldi r31,high(znak*2)
		
s0:
			cpi r16,0
			breq s1
			adiw r31:r30,5
			dec r16
			rjmp s0
	
s1:			ldi r21,5
	
s3:			lpm 
			rcall out_
			brtc s33
			lpm
			rcall out_
s33:
			adiw r31:r30,1
			dec r21
			brne s3
			clr r0
			rcall out_
			brtc s44
			clr r0
			rcall out_
s44:		ret

out_:
			ldi r20,8
s2:	
			mov r17,r5
			sbrc r0,0
			mov r17,r4	
			rcall i2c_out
			brtc s22
			rcall i2c_out
s22:
			ror r0
			dec r20
			brne s2
			inc r6
			rcall set_xy
			ret


shbyte:		;   r19   
			mov r16,r19	
			andi r16,$f0
			swap r16
			rcall tetr
			mov r16,r19
			andi r16,$0f
			rcall tetr
			ldi r16,' '
			rcall symbol
			ret
	
tetr:		;   r16
			cpi r16,10
			brcs te1
			ldi r17,$41-$0a
			rjmp te2
te1:
			ldi r17,$30
te2:
			add r16,r17
			rcall symbol
			ret

/*

 0- 
 1- 
 2- 
 3- 
 4- 
 5- 
 6- 
 7- 
 	 :   r16  ,  -   , 07    
*/
set_color:
			ldi r30,low(color*2)
			push r30
			ldi r31,high(color*2)
			mov r17,r16
			andi r17,$07
			add r30,r17
			lpm r4,z
			pop r30
			mov r17,r16
			swap r17
			andi r17,$07
			add r30,r17
			lpm r5,z
			ret

;   ,  ,  set_color
lcd_clr:
			ldi r21,80
cl_2:	
			ldi r20,104
cl_1:
			mov r17,r5
			rcall i2c_out
			dec r20
			brne cl_1
			dec r21
			brne cl_2
			ret


; -
hexx:
	ser     r16
hexx0:
	sub     r17,r23
	sbc     r18,r24
	sbc		r19,r25
	inc     r16
	brcc    hexx0
	add     r17,r23
	adc     r18,r24
	adc		r19,r25
	ret

byte:	;  r17

	ldi r28,$10
	ldi r29,$01
	clr r18
	clr r19
	rjmp bytet

;    r20,r21,r22  
hex:	
	ldi r28,$10
	ldi r29,$01
	mov r17,r20
	mov r18,r21
	mov r19,r22

	ldi r23,$40
	ldi r24,$42
	ldi r25,$0f
	rcall hexx
	st y+,r16

	ldi r23,$a0
	ldi r24,$86
	ldi r25,$01
	rcall hexx
	st y+,r16

	ldi r23,$10
	ldi r24,$27
	ldi r25,$0
	rcall hexx
	st y+,r16

	ldi r23,$e8
	ldi r24,$03
	ldi r25,$0
	rcall hexx
	st y+,r16

bytet:	
	ldi r23,$64
	ldi r24,$0
	ldi r25,$0
	rcall hexx
	st y+,r16
	
	ldi r23,$0a
	ldi r24,$0
	ldi r25,$0
	rcall hexx
	st y+,r16

	st y,r17
	ret

;     

small:
	ldi r28,$10
	ldi r29,$01
	cbi _gpior0,5

	ldi r23,3
hex0:
	ld r16,y+
	cpi r16,0
	breq zam
	sbi _gpior0,5
hex00:
	rcall tetr
hex01:	
	dec r23
	brne hex0
	ldi r16,'.'
	rcall symbol
	ld r16,y+
	rcall tetr
	ld r16,y+
	rcall tetr
	ld r16,y+
	rcall tetr
	ldi r16,'.'
	rcall symbol
	ld r16,y
	rcall tetr

	ret
zam:
	sbic _gpior0,5
	rjmp hex00
	ldi r16,' '
	rcall symbol
	rjmp hex01

	

;  EEPROM
;  R16   R17
write:

wrt0:
	sbic _eecr,1		; 
	rjmp wrt0
	out _eearl,r16		; 
	clr r18
	out _eearh,r18		;   
	out _eedr,r17		; 
	sbi _eecr,2		; 
	sbi _eecr,1		;
	inc r16			; 
	out _eearl,r18
	out _eearh,r18		; 
	ret



; EEPROM
;  R16  R17, ++
read:
read00:
	sbic _eecr,1		; 
	rjmp read00		;
	out _eearl,r16		; 
	clr r18
	out _eearh,r18		;   
	sbi _eecr,0		;  EEPROM
read1:
	sbic _eecr,0		;
	rjmp read1
	in r17,_eedr		;  EEPROM
	inc r16			; 
	out _eearl,r18
	out _eearh,r18		; 
	ret

color:
	.db $0,$c0,$07,$c7,$38,$f8,$3f,$ff

znak:
	.include "znak6.txt"

